#ifndef DIMDIALOG_h
#define DIMDIALOG_h

#include <qdialog.h>
#include <qgroupbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>


//! Class DimDialog
/*!
    Diese Klasse ist eine Subklasse von QDialog. Sie erzeugt einen Dialog zum Eingeben
	der Dimesnion des Datensatzes.
*/
class DimDialog : public QDialog 
{
    Q_OBJECT
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen.
	*/
    DimDialog(QWidget *parent = 0, const char *name = "set File-Dimension", bool modal = TRUE, WFlags f = 0);
    //! Destruktor
	~DimDialog() {}
	//! Methode getValues
	/*!
		Gibt die eingegebene Dimension zur&uuml;ck.
	*/
    void getValues(int dimension [3]);
    
    
	/*!
		Variable ist true, wenn Dialog mit OK beendet wird.
	*/
	bool flag;
    
private:
    QGroupBox *group;
    QLineEdit *xdim;
    QLineEdit *ydim;
    QLineEdit *zdim;
    QPushButton *okay;
    QPushButton *cancel;
    int dim [3];
    
protected slots:
    void okayAction();	    
};

#endif
