#ifndef DITHANIM_STARTPOINTIMPL_h
#define DITHANIM_STARTPOINTIMPL_h

#include <qwidget.h>

#include "DithAnim_startPoint.h"
#include "DithAnim_struct.h"


//! Class DithAnim_startPointImpl
/*!
    Diese Klasse ist abgeleitet von der Klasse DithAnim_startPoint. In ihr sind die 
	Methoden fr die Actions im Dialog ausprogrammiert.
*/
class DithAnim_startPointImpl : public DithAnim_startPoint
{
    Q_OBJECT;
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen. point ist eine Struktur, 
		welche den Startpunkt enth&auml;t.
	*/
    DithAnim_startPointImpl(QWidget* parent, const char* name, DithAnim_struct point);
    //! Destruktor
	~DithAnim_startPointImpl();
	//! Methode getExitStatus
	/*!
		Gibt true zur&uuml;ck, wenn der Dialog mit OK beendet wurde.
	*/
	bool getExitStatus();
	//! Methode getDithAnimStruct
	/*!
		Gibt die neuen Werte des Startpunkts in einer Struktur zur&uuml;ck.
	*/
	DithAnim_struct getDithAnimStruct();
    
public slots:
	//! Slot xRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die x-Rotation bewegt wird.
	*/
    void xRotSliderChanged(int value);
	//! Slot yRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die y-Rotation bewegt wird.
	*/
	void yRotSliderChanged(int value);
	//! Slot zRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die z-Rotation bewegt wird.
	*/
	void zRotSliderChanged(int value);
	//! Slot zoomSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r den Zoom bewegt wird.
	*/
	void zoomSliderChanged(int value);
	//! Slot okayButtonClicked
	/*!
		Wird aufgerufen wenn der OK Button geclickt wird.
	*/
	void okayButtonClicked();
	//! Slot distanceSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die Distanz der Dithering Quader bewegt wird.
	*/
	void distanceSliderChanged(int value);
	//! Slot sizeSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die Gr&ouml;sse der Dithering Quader bewegt wird.
	*/
	void sizeSliderChanged(int value);
	//! Slot secRowClicked
	/*!
		Wird aufgerufen wenn die Cehck Box f&uuml;r die Anzeige der Dithering in der zweiten
		Reihe geclickt wird.
	*/
	void secRowClicked(bool status);
    
private:
	bool getValues();
	void setValues();

	DithAnim_struct anim;
	bool exitStatus;
};


#endif