#include <stdlib.h>
#include <stdio.h>
#include <qregexp.h>
#include <qcolor.h>
#include <iostream.h>

#include "FCReader.h"


FCReader::FCReader(QString file)
{
    pwFunc = vtkPiecewiseFunction::New();
    filename = file;
}


FCReader::~FCReader()
{
}
    

bool FCReader::read()
{
    FILE *file;
    file = fopen (filename, "rt");
    char *line = new char [256];
    bool flag = true;
    int i = 0;
    // if File could not been opened
    if (file == NULL)
    {
		return false;
    }
    // get numbers of Transfer Functions
    fgets(line, 255, file);
    QString length = line;
    int size = length.toInt(&flag);
    if (!flag)
    {
		return false;
    }
    // define array for reading Transfer Functions
    QString *string = new QString [size+7];
    // read line by line from file
    while (fgets (line, 255, file) != NULL && i < size+7)
    {
		string[i] = line;
		i++;
    }
    fclose (file);

	if (i != size+7)
		return false;
    
    float x;
	float value;
	QRegExp rxp = QRegExp ("%", TRUE, FALSE);
    for (i = 0; i < size; i++)
    {
		flag = true;
		if (string[i].contains(rxp) != 2)
		{
			return false;
		}
		x = string[i].section(rxp, 0, 0).toFloat(&flag);
		if (!flag)
			return false;
		value = string[i].section (rxp, 1, 1).toFloat(&flag);
		if (!flag)
			return false;
		pwFunc->AddPoint(x, value);
    }
	flag = true;
	int r, g, b;
	if (string[size].contains(rxp) != 3)
		return false;
	r = string[size].section(rxp, 0, 0).toInt(&flag);
	g = string[size].section(rxp, 1, 1).toInt(&flag);
	b = string[size].section(rxp, 2, 2).toInt(&flag);
	if (!flag)
		return false;
	color = QColor(r, g, b);
	bool flag1, flag2, flag3, flag4, flag5, flag6;
	transferCoefficient = string[size+1].toFloat(&flag1);
	ksc = string[size+2].toFloat(&flag2);
	kss = string[size+3].toFloat(&flag3);
	kse = string[size+4].toFloat(&flag4);
	redOffset = string[size+5].toFloat(&flag5);
	redFactor = string[size+6].toFloat(&flag6);
    return true;
}


void FCReader::getFCSettings(vtkPiecewiseFunction *pwF, QColor *col, float *transF, float *k_sc, float *k_ss, float *k_se, float *red_offset, float *red_factor)
{
	int length = pwFunc->GetSize();
	float *data = pwFunc->GetDataPointer();
	for (int i = 0; i < length; i++)
	{
		pwF->AddPoint(data[2*i], data[2*i+1]);
	}
	*col = color;
	*transF = transferCoefficient;
	*k_sc = ksc;
	*k_ss = kss;
	*k_se = kse;
	*red_offset = redOffset;
	*red_factor = redFactor;
}