#ifndef FCREADER_H
#define FCREADER_H


#include <qstring.h>

#include "vtkPiecewiseFunction.h"


//! Class FCReader
/*!
    Diese Klasse ist zust&auml;ndig die Focus+Context Parameter aus einer Datei
	zu laden.
*/
class FCReader
{
  public:
	//! Konstruktor
	/*!
		Setzt den Dateinamen und initialisiert Variablen.
	*/
    FCReader(QString file);
	//! Destruktor
    ~FCReader();
	//! Methode read
	/*!
		Liest die Focus+Context Settings aus der Datei. Gibt true zur&uuml;ck, wenn der Lesezugriff
		erfolgreich war.
	*/
    bool read();
	//! Methode getFCSettings
	/*!
		Setzt die Adressen der &Uuml;bergabewerte auf die der eingelesenen Werte.
	*/
    void getFCSettings(vtkPiecewiseFunction *pwF, QColor *col, float *transF, float *k_sc, float *k_ss, float *k_se, float *red_offset, float *red_factor);
    
  private:
    vtkPiecewiseFunction* pwFunc;
	QColor color;
	float transferCoefficient;
	float ksc, kss, kse;
	float redOffset, redFactor;
    QString filename;
};

#endif  // FCREADER