#include <stdlib.h>
#include <stdio.h>
#include <qcolor.h>

#include "FCWriter.h"



FCWriter::FCWriter (QString file)
{
    filename = file;
}


FCWriter::~FCWriter ()
{
}


bool FCWriter::write(vtkPiecewiseFunction *pwFunc, QColor col, float transF, float k_sc, float k_ss, float k_se, float red_offset, float red_factor)
{
    int length, i;
    length = pwFunc->GetSize();
    if (length > 0)
    {
		QString header = QString::number(length) + "\n";
		FILE *file;
	
		file = fopen(filename, "wt+");
		if (file == NULL)
		{
			return false;
		}

		float *data = pwFunc->GetDataPointer();
	
		fputs (header, file);
	
		for (i = 0; i < length; i++)
		{
			QString line = QString::number(data[2*i]) + "%" + QString::number(data[2*i+1]) + "%\n";
			fputs(line, file);
		}

		QString temp = QString::number(col.red()) + "%" + QString::number(col.green()) + "%" + QString::number(col.blue()) + "%\n";
		fputs(temp, file);
		temp = QString::number(transF) + "\n";
		fputs(temp, file);
		temp = QString::number(k_sc) + "\n";
		fputs(temp, file);
		temp = QString::number(k_ss) + "\n";
		fputs(temp, file);
		temp = QString::number(k_se) + "\n";
		fputs(temp, file);
		temp = QString::number(red_offset) + "\n";
		fputs(temp, file);
		temp = QString::number(red_factor) + "\n";
		fputs(temp, file);

		fclose(file);
    }
    return true;
}
