#ifndef FCWRITER_H
#define FCWRITER_H

#include <qstring.h>

#include "vtkPiecewiseFunction.h"


//! Class FCWriter
/*!
    Diese Klasse schreibt die Focus+Context Parameter in eine Datei.
*/
class FCWriter
{
  public:
	//! Konstruktor
	/*!
		Setzt den Dateinamen und initialisiert Variablen.
	*/
    FCWriter(QString file);
	//! Destruktor
    ~FCWriter();
	//! Methode write
	/*!
		Schreibt die Focus+Context Settings in eine Datei.
	*/
    bool write(vtkPiecewiseFunction *pwFunc, QColor col, float transF, float k_sc, float k_ss, float k_se, float red_offset, float red_factor);
    
  private:
    QString filename;
};

#endif