#include <iostream.h>


#include "focalEditorImpl.h"
#include "focalWidget.h"


focalEditorImpl::focalEditorImpl (QWidget *parent, const char* name, int *dimension, float *orient, double* focPoint) : focalEditor (parent, name)
{
    focalPoint = new double [3];
    orientation = new float [3];
    dim = new int [3];
    for (int i = 0; i < 3; i++)
    {
		focalPoint[i] = focPoint[i] - (double)(dimension[i])/2;
		orientation[i] = orient[i];
		dim[i] = dimension[i];
    }
    okay = false;
    //cout << "focal Point: " << focalPoint[0] << ", " << focalPoint[1] << ", " << focalPoint[2] << "\n";
    frontView->setView(dim, orientation, focalPoint, "front");
    uprightView->setView(dim, orientation, focalPoint, "upright");
}


focalEditorImpl::~focalEditorImpl ()
{
}


void focalEditorImpl::okayButtonPressed ()
{
    focalPoint = frontView->getFocalPoint ();
    for (int i = 0; i < 3; i++)
    {
		focalPoint[i] = focalPoint[i] + (double)(dim[i])/2;
    }
    okay = true;
    this->close ();
}


double* focalEditorImpl::getFocalPoint ()
{
    return focalPoint;
}
