#ifndef FOCALEDITORIMPL_h
#define FOCALEDITORIMPL_h

#include <qwidget.h>

#include "focalEditor.h"


//! Class focalEditorImpl
/*!
    Die Klasse ist abgeleitet von focalEditor und ist f&uuml;r die Abl&auml;ufe
	im Dialog zum Setzen des Fokuspunkts zust&auml;ndig.
*/
class focalEditorImpl : public focalEditor
{
    Q_OBJECT;
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen. Die weiteren Parameter
		beschreiben den Datensatz und dessen Orientierung sowie den aktuellen Fokuspunkt.
	*/
    focalEditorImpl(QWidget* parent, const char* name, int *dimension, float* orient, double *focPoint);
    //! Destruktor
	~focalEditorImpl();
	//! Methode getFocalPoint
	/*!
		Gibt den derzeitig ausgew&auml;hlten Fokuspunkt zur&uuml;ck.
	*/
    double* getFocalPoint();


	/*!
		Ist true, wenn der Dialog mit OK beendet wird.
	*/
    bool okay;
    
public slots:
    void okayButtonPressed();
    
private:
    double *focalPoint;
    float *orientation;
    int *dim;
};


#endif
