#ifndef GOREADER_H
#define GOREADER_H


#include <qstring.h>

#include "vtkPiecewiseFunction.h"


//! Class FCReader
/*!
    Diese Klasse ist zust&auml;ndig die Parameter f&uuml;r die gradient Opacity aus einer Datei
	zu laden.
*/
class GOReader
{
  public:
	//! Konstruktor
	/*!
		Setzt den Dateinamen und initialisiert Variablen.
	*/
    GOReader(QString file);
	//! Destruktor
    ~GOReader();
	//! Methode read
	/*!
		Liest die Gradient Transfer Function aus der Datei. Gibt true zur&uuml;ck, wenn der Lesezugriff
		erfolgreich war.
	*/
    bool read();
	//! Methode getPiecewiseFunction
	/*!
		Gibt die Gradienten TRansfer Function zur&uuml;ck.
	*/
    vtkPiecewiseFunction* getPiecewiseFunction();
    
  private:
    vtkPiecewiseFunction* pwFunc;
    QString filename;
};

#endif  // GOREADER