#ifndef MLANIMATIONEDITORIMPL_h
#define MLANIMATIONEDITORIMPL_h

#include <qwidget.h>

#include "MLAnimationEditor.h"
#include "MLAnim_struct.h"



//! Class MLAnimationEditorImpl
/*!
    Die Klasse ist abgeleitet von MLAnimationEditor und ist f&uuml;r die Abl&auml;ufe
	im Magic Lamp Animationsfenster zust&auml;ndig.
*/
class MLAnimationEditorImpl : public MLAnimationEditor
{
    Q_OBJECT;
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen. startPoint &uuml;bergibt
		die aktuellen Einstellungen f&uuml;r Magic Lamp.
	*/
    MLAnimationEditorImpl(QWidget* parent, const char* name, MLAnim_struct startPoint);
    //! Destruktor
	~MLAnimationEditorImpl();
	//! Methode getExitStatus
	/*!
		Gibt true zur&uuml;ck wenn der Dialog mit OK beendet wird.
	*/
	bool getExitStatus();
	//! Methode getMLAnimStruct
	/*!
		Gibt einen Array mit den Animationspunkten zur&uuml;ck.
	*/
	MLAnim_struct *getMLAnimStruct();
	//! Methode getNumbers
	/*!
		Gibt die Anzahl der Animationspunkte zur&uuml;ck.
	*/
	int getNumbers();
    
public slots:
	//! Slot deletePointButtonClicked
	/*!
		Wird aufgerufen wenn auf den Delete Animations Punkt Button geclickt wird.
	*/
    void deletePointButtonClicked();
	//! Slot editPointButtonClicked
	/*!
		Wird aufgerufen wenn auf den Edit Animations Punkt Button geclickt wird.
	*/
	void editPointButtonClicked();
	//! Slot newPointButtonClicked
	/*!
		Wird aufgerufen wenn auf den New Animations Punkt Button geclickt wird.
	*/
	void newPointButtonClicked();
	//! Slot startAnimationButtonClicked
	/*!
		Wird aufgerufen wenn auf den Start Animation Button geclickt wird.
	*/
	void startAnimationButtonClicked();
	//! Slot startAnimationButtonClicked
	/*!
		Wird aufgerufen wenn auf den Start Punkt Button geclickt wird.
	*/
	void startPointButtonClicked();
    
private:
	MLAnim_struct *anim;
	int number;
	bool exitStatus;
	int frames;
};


#endif