
#include <stdlib.h>
#include <stdio.h>
#include <qregexp.h>
#include <qcolor.h>
#include <iostream.h>

#include "tfReader.h"


TFReader::TFReader (QString file)
{
    transFunc = new transferFunction ();
    filename = file;
}


TFReader::~TFReader ()
{
}
    

bool TFReader::read ()
{
    //cout<<"read anfang\n";
    FILE *file;
    file = fopen (filename, "rt");
    char *line = new char [256];
    bool flag = true;
    int i = 0;
    // if File could not been opened
    if (file == NULL)
    {
		return false;
    }
    // get numbers of Transfer Functions
    fgets (line, 255, file);
    QString length = line;
    int size = length.toInt(&flag);
    if (!flag)
    {
		return false;
    }
    // define array for reading Transfer Functions
    QString *string = new QString [size];
    // read line by line from file
    while (fgets (line, 255, file) != NULL && i < size)
    {
		string[i] = line;
		i++;
    }
    fclose (file);
    
    QRegExp rxp = QRegExp ("%", TRUE, FALSE);
    for (i = 0; i < size; i++)
    {
		transfer_element element;
		flag = true;
		if (string[i].contains (rxp) != 8 || string[i].section (rxp, 1).contains ("-"))
		{
			return false;
		}
		element.name = string[i].section (rxp, 0, 0);
		int r, g, b;
		r = string[i].section (rxp, 1, 1).toInt(&flag);
		g = string[i].section (rxp, 2, 2).toInt(&flag);
		b = string[i].section (rxp, 3, 3).toInt(&flag);
		if (r > 255 || g >255 || b > 255 || r < 0 || g < 0 || b <0)
		{
			return false;
		}
		QColor color;
		color.setRgb (r, g, b);
		element.color = color;
		element.opacity = string[i].section (rxp, 4, 4).toFloat(&flag);
		element.begin = string[i].section (rxp, 5, 5).toFloat(&flag);
		element.length = string[i].section (rxp, 6, 6).toFloat(&flag);
		element.angle_left = string[i].section (rxp, 7, 7).toInt(&flag);
		element.angle_right = string[i].section (rxp, -1, -1).toInt(&flag);
		if (!flag)
		{
			return false;
		}
		//cout<<"add elem\n";
		transFunc->addElement (element);
    }
    //cout<<"read ende\n";
    return true;
}


transferFunction* TFReader::getTransferFunctions ()
{
    return transFunc;
}
