#ifndef TFREADER_H
#define TFREADER_H


#include <qstring.h>

#include "transferFunction.h"


//! Class TFReader
/*!
    Diese Klasse ist zust&auml;ndig die Transfer Function aus einer Datei
	zu laden.
*/
class TFReader
{
  public:
	//! Konstruktor
	/*!
		Setzt den Dateinamen und initialisiert Variablen.
	*/
    TFReader(QString file);
	//! Destruktor
    ~TFReader();
	//! Methode read
	/*!
		Liest die Transfer Function aus der Datei.
	*/
    bool read();
	//! Methode getTransferFunctions
	/*!
		Gibt die eingelesene Transfer Function zur&uuml;ck.
	*/
    transferFunction* getTransferFunctions();
    
  private:
    transferFunction* transFunc;
    QString filename;
};

#endif  // TFREADER
