
#include <stdlib.h>
#include <stdio.h>
#include <qcolor.h>

#include "tfWriter.h"



TFWriter::TFWriter (QString file)
{
    filename = file;
}


TFWriter::~TFWriter ()
{
}


bool TFWriter::write (transferFunction *transFunc)
{
    int length, i;
    transfer_function tf = transFunc->tf;
    length = tf.length;
    if (length > 0)
    {
		QString header = QString::number (length) + "\n";
		FILE *file;
	
		file = fopen (filename, "wt+");
		if (file == NULL)
		{
			return false;
		}
	
		fputs (header, file);
	
		for (i = 0; i < length; i++)
		{
			transfer_element element = tf.element[i];
			QString line = makeString (element);
			fputs (line, file);
		}
	
		fclose (file);
    }
    return true;
}


QString TFWriter::makeString (transfer_element element)
{
    QString out;
    QString sep = "%", end = "\n";
    QString name, r, g, b, opacity, begin, length, angle_left, angle_right;
    
    name = element.name;
    QColor color = element.color;
    int red, green, blue;
    red = color.red ();
    green = color.green ();
    blue = color.blue ();
    r = QString::number (red);
    g = QString::number (green);
    b = QString::number (blue);
    opacity = QString::number (element.opacity);
    begin = QString::number (element.begin);
    length = QString::number (element.length);
    angle_left = QString::number (element.angle_left);
    angle_right = QString::number (element.angle_right);
    
    out = name + sep + r +sep + g +sep + b +sep + opacity +sep + begin +sep + length +sep +angle_left +sep + angle_right +end;
    
    return out;
}
