#ifndef TRANSFERFUNCTIONEDITORIMPL_H
#define TRANSFERFUNCTIONEDITORIMPL_H

#include <qwidget.h>

#include "transferFunction.h"
#include "transferFunctionEditor.h"



//! Class transferFunctionEditorImpl
/*!
    Diese Klasse ist eine Subklasse von transferFunctionEditor. Sie Implementiert die Methoden
	der Subklasse.
*/
class transferFunctionEditorImpl : public transferFunctionEditor
{
    
  public:
	//! Konstruktor
	/*!
		Default Konstruktor, setzt &uuml;bergebenen Parameter.
	*/
    transferFunctionEditorImpl(QWidget* parent, const char* name, unsigned int histo [256]);
    //! Konstruktor
	/*!
		Konstruktor, setzt &uuml;bergebenen Parameter.
	*/
	transferFunctionEditorImpl(QWidget* parent, const char* name, unsigned int histo [256], transferFunction transFunction);
	//! Destruktor
	~transferFunctionEditorImpl();
    void functionSelectorPressed(QListBoxItem *item);
    void nameChanged(const QString &newName);
    void colorButtonPressed();
    void opacityChanged(int value);
    void beginChanged(int value);
    void endChanged(int value);
    void slope_leftChanged(int value);
    void slope_rightChanged(int value);
    void newButtonPressed();
    void deleteButtonPressed();
    void saveButtonPressed();
    void loadButtonPressed();
    void okayButtonPressed();
    
    //! Methode getExitStatus
	/*!
		returned true wenn mit Dialog mit OK Button geschlossen wird.
	*/
	bool getExitStatus();
	//! Methode getSaveStatus
	/*!
		returned true wenn auf TransferFunction-Speichern geklickt wurde.
	*/
	bool getSaveStatus();
	//! Methode getChanges
	/*!
		returned true wenn sich etwas ge&auml;ndert hat.
	*/
    bool getChanges();
	//! Methode getTransferFunction
	/*!
		Gibt die transferFunction zur&uuml;ck.
	*/
    transferFunction* getTransferFunction();   
    
  private:
    void setEnableElements(bool enable);
    void setEditorFields();
    void setCurrentValues(transfer_element element);
    bool nameChangedExit();
    
    bool changes, exitStatus, saveStatus, beginChange, endChange, nameChange, deleteChange;
    transferFunction *transFunc;
};

#endif // TRANSFERFUNCTIONEDITORIMPL_H
